function Xs = st(X,tau)
% Soft-thresholding/shrinkage operator
% 
% Syntax:       Xs = st(X,tau)
%
% Inputs:       X is the input matrix
%               tau is the input shrinkage parameter
%
% Outputs:      Xs is the result of applying soft thresholding to every element in X
    
Xs = sign(X).*max(abs(X) - tau,0);
