clear
close all

m = 100;
n = 50;

%% test st.m
x = ones(n,1);
y = linspace(-1,1,m)';
tau = 0.5;

% generate matrix and threshold
A = x*y';
As = st(A,tau);

% display results
figure
imagesc(y,x,A)
caxis([-1 1])
colormap gray
colorbar
title('original matrix')

figure
imagesc(y,x,As)
caxis([-1 1])
colormap gray
colorbar
title('soft-thresholded matrix')

figure
hold all
plot(A(1,:))
plot(As(1,:))
legend('original row','soft-thresholded row')

%% test svt.m
D = 100;
N = 500;
r = 13;
tau = 50;

% generate matrix and threshold
A = randn(D,r)*randn(r,N) + randn(D,N);
As = svt(A,tau);

% display results
figure
stem(svd(A))
title('\sigma(A)')

figure
stem(svd(As))
title('\sigma(svt(A))')
