"""
RPCA - demo - st.py

ECE 510

python version: 3.7.3

Spring 2019
"""

import numpy as np
from numpy import sign, amax, absolute

def st(X, tau):
    r"""
    Soft - thresholding/shrinkage operator

    Syntax:     Xs = st(X, tau)

    Input: 
    :param X: Input matrix
    :param tau: Shrinkage parameter

    Output:
    Xs: The result of applying soft thrsholding to every element in X
    """
    Xtemp = abs(X) - tau
    Xtemp[Xtemp < 0.0] = 0.0
    Xs = sign(X) * Xtemp

    return Xs
